### Searches a glossary database
### Steve Dodson
### 8/29/00

use CGI qw(:standard);
print header();
print "<HTML><HEAD>\n<TITLE>NMD Doc Search</TITLE>\n";
print "<STYLE TYPE=\"text\/css\">\n";
print "a\:link \{ color\:navy\; font-size\:11pt\; font-family\: Arial, Helvetica, san-serif\; text-decoration\: none \}\n";
print "a\:visited \{ color\:maroon\; font-size\:11pt\; font-family\: Arial, Helvetica, san-serif\; text-decoration\: none \}\n";
print "a\:active \{ color\:purple\; font-size\:11pt\; font-family\: Arial, Helvetica, san-serif\; text-decoration\: none \}\n";
print "a\:hover \{ color\:navy\; font-size\:11pt\; font-family\: Arial, Helvetica, san-serif\; text-decoration\: underline \}\n";
print "td, p \{ color\:black\; font-size\:11pt\; font-family\: Arial, Helvetica, san-serif \}\n";
print "h3 \{ color\:navy\; font-size\:14pt\; font-family\: Arial, Helvetica, san-serif; font-weight\: bold \}\n";
print "h1 \{ color\:navy\; font-size\:19pt\; font-family\: Arial, Helvetica, san-serif; font-weight\: bold \}\n";
print "</STYLE>\n</HEAD>\n";
print "<BODY BACKGROUND=\"nmdshield2.jpg\">\n<A NAME=\"top\"></A>";

my $searchString = param("search");
my $searchBy1 = param("searchBy1");
my $searchBy2 = param("searchBy2");

if ($searchString eq "") 
{
   print "<H2 ALIGN=\"Center\">Error: You did not enter any search criteria!</H2>";
   print "<P><A HREF=\"javascript:history.back()\" STYLE=\"text-decoration\: underline\">Back</A></P>";
}
else 
{
   ### Make DB Connection
   use Win32::ODBC;
   $db = new Win32::ODBC("CGI");
### Search by Meta AND Title
   if ($searchBy1 && $searchBy2) 
   {
      allSearch("Title", "Meta");
    }
### Search by Title
   elsif ($searchBy1)
   {
      oneSearch("Title");
   }
### Search by Meta
   elsif ($searchBy2)
   {
      oneSearch("Meta");
   }
### Default searches both
   else
   {
      allSearch("Title", "Meta");
   }

### Get a row count - used also for an error check
   $x = 0;
   while ($db->FetchRow()) 
   {
      $titleArray[$x] = $db->Data("Title");
      $commentsArray[$x] = $db->Data("Comments");
      $linksArray[$x] = $db->Data("Links");
      $x++;
   }
### If $x didn't increment there were no matches
   if ($x == 0) 
   {
     print "<H3 ALIGN = center>There were no matches for your query</H3><A HREF=\"javascript:history.back()\"";
     print " STYLE=\"text-decoration\: underline\">Back</A>";
     print "</BODY></HTML>";
     exit;
   }
   else 
   {
     print "<H1 ALIGN=\"center\">Search Results</H1>";
     print "<H3 ALIGN=\"center\">The Query String \'$searchString\' produced $x matches. </h3>";
     print "<P><A HREF=\"javascript:history.back()\" STYLE=\"text-decoration\: underline\">Back</A></P>";
     print "<TABLE ALIGN=\"Center\" BORDER=\"1\" WIDTH=\"100\%\" BGCOLOR=\"white\">\n";
     print "<TR BGCOLOR=\"Silver\" ALIGN=\"Center\" VALIGN=\"Center\">\n";
     print "<TD STYLE=\"font-size: 14pt; color: navy\">#</TD>\n<TD STYLE=\"font-size: 14pt; color: navy\">Document Title";
     print "</TD>\n<TD STYLE=\"font-size: 14pt; color: navy\">Comments</TD>\n</TR>\n";

### Print out matches
     $i = 0;
     for ( @titleArray )
     {
### Using $i to count for the array and $ii to number the matches in the html output
        $ii = $i + 1;
        print "<TR VALIGN=\"Top\">\n";
        print "<TD>$ii</TD>\n";
        if ($linksArray[$i]) 
        {
           print "<TD><A HREF=$linksArray[$i]>$titleArray[$i]</A><BR></TD>\n";
           if (!$commentsArray[$i])
          {
             print "<TD>&nbsp;</TD>";
          }
          else
         {
            print "<TD>$commentsArray[$i]</TD>\n";
          }
       print "</TR>\n";
       }
    else 
    {
        print "<TD>$titleArray[$i]</TD>\n";
        if (!$commentsArray[$i])
       {
          print "<TD>&nbsp;</TD>";
       }
       else
       {
          print "<TD>$commentsArray[$i]</TD>\n";
       }
     print "</TR>\n";
    }
   $i++;
}
print "</TABLE>\n<BR><BR><P><A HREF=\"#top\"><IMG SRC=\"up.gif\" BORDER=\"0\"></A> Top</P>";
   }

}
print "</BODY></HTML>";
$db-->close();

### Begin Subs ###
sub oneSearch
{
   $db->Sql("SELECT * FROM NMD_Library WHERE $_[0] LIKE '%$searchString%' ORDER BY ID");
}

sub allSearch
{
   $db->Sql("SELECT * FROM NMD_Library WHERE $_[0] LIKE '%$searchString%' OR $_[1] LIKE '%$searchString%' ORDER BY ID");
}
